///////////////////////////////////////////////////////////////////////////////////
//by
///////////////////////////////////////////////////////////////////////////////////
float Script : STANDARDSGLOBAL <
	string ScriptOutput = "color";
	string ScriptClass = "scene";
	string ScriptOrder = "postprocess";
> = 0.8;

float Scale : CONTROLOBJECT < string name = "(self)"; string item = "Si"; >;
float Tr : CONTROLOBJECT < string name = "(self)"; string item = "Tr"; >;
float AcsRx : CONTROLOBJECT < string name = "(self)"; string item = "Rx"; >;
float AcsRy : CONTROLOBJECT < string name = "(self)"; string item = "Ry"; >;

static float BaseRate = Scale*0.1;
float4x4 WorldMatrix     : WORLD;
static float3 EPos = WorldMatrix._41_42_43;

float4x4 ViewMatrix      : VIEW;
static float3x3 VMat =
{ { ViewMatrix._11, ViewMatrix._12, ViewMatrix._13 },
{ ViewMatrix._21, ViewMatrix._22, ViewMatrix._23 },
{ ViewMatrix._31, ViewMatrix._32, ViewMatrix._33 },
};


static float Si=Scale*0.1;

// XN[TCY
float2 ViewportSize : VIEWPORTPIXELSIZE;
static float2 ViewportOffset = (float2(0.5,0.5)/ViewportSize);

#define SAMPNUM 14

float ClearDepth = 1.0;
float4 ClearColor= float4(0,0,0,1);

texture2D DepthBuffer : RENDERDEPTHSTENCILTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	string Format = "D24S8";
>;

texture2D ScnMap : RENDERCOLORTARGET <
	float2 ViewPortRatio = { 1.0, 1.0 };
	int MipLevels = 1;
string Format = "A16B16G16R16F";
>;
sampler2D ScnSamp = sampler_state {
	texture = <ScnMap>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

texture RimNDMapRT: OFFSCREENRENDERTARGET <
	string Description = "SenNDmap";
	string Format = "A32B32G32R32F";
	float4 ClearColor = { 0, 0, 0, 10000 };
	float ClearDepth = 1.0;
	bool AntiAlias = true;
	int Miplevels = 1;
	string DefaultEffect =
		"self = hide;"
		"* = RimDepth.fx;";
>;
sampler NDSamp = sampler_state {
	Texture = (RimNDMapRT);
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = LINEAR;
	AddressU = CLAMP;
	AddressV = CLAMP;
};

////////////////////////////////////////////////////////////////////////////////////////////////
struct VS_OUTPUT {
	float4 Pos            : POSITION;
	float2 Tex            : TEXCOORD0;
};

VS_OUTPUT VS_passDraw(float4 Pos : POSITION, float4 Tex : TEXCOORD0) {
	VS_OUTPUT Out = (VS_OUTPUT)0;

	Out.Pos = Pos;
	Out.Tex = Tex + ViewportOffset;
	return Out;
}
////////////////////////////////////////////////////////////////////////////////////////////////
float4 PS_passB(float2 Tex: TEXCOORD0) : COLOR
{
	float4 Color=tex2D(ScnSamp, Tex);
	float ND1 = tex2D(NDSamp, Tex);


	float2 NDTex = Tex + EPos.xy / (min(50,ND1) + 10.0)*0.05;

	float ND2 = tex2D(NDSamp, NDTex);


	float Rate = saturate((ND2 - ND1 - ND1*0.01 - 0.1) * 10);
	Color.rgb = Color.rgb + (Color.rgb*0.5 + 0.5)*Rate*Tr;



	return Color;
}
////////////////////////////////////////////////////////////////////////////////////////////////

technique COLOR <
	string Script =

	"RenderColorTarget0=ScnMap;"
	"RenderDepthStencilTarget=DepthBuffer;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"ScriptExternal=Color;"


	"RenderColorTarget0=;"
	"RenderDepthStencilTarget=;"
	"ClearSetColor=ClearColor;"
	"ClearSetDepth=ClearDepth;"
	"Clear=Color;"
	"Clear=Depth;"
	"Pass=B;"
	;

> {
	pass B < string Script = "Draw=Buffer;"; > {
		AlphaBlendEnable = FALSE;
		AlphaTestEnable = FALSE;
		VertexShader = compile vs_3_0 VS_passDraw();
		PixelShader = compile ps_3_0 PS_passB();
	}
}
////////////////////////////////////////////////////////////////////////////////////////////////
